/*
 * Name:     CTimeline.h
 *
 *
 * Class:    CTimeline
 * Impl:     CTimeline.cpp
 * Created : Mar 10, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CTIMELINE_H_
#define CTIMELINE_H_

#include "Channel/CAnimChannel.h"
#include <cmath>
#include <vector>

/*
 * Class:    CTimeline
 * 
 */
class CTimeline
{
public:
	CTimeline();
	virtual ~CTimeline();

	double GetDuration() const {return double(mNumFrames) / double(mFrameRate);}
	void AddChannel(CAnimChannel *channel);
	unsigned int GetCurrentFrame() const {return floor(mFrameRate * mCurrentTime);}

	void SetNumFrames(int f) {mNumFrames = f;}
	unsigned int GetNumFrames() const {return mNumFrames;}
	void SetFrameRate(int r) {mFrameRate = r;}
	unsigned int GetFrameRate() const {return mFrameRate;}
	void SetCurrentTime(double t);
	double GetCurrentTime() const {return mCurrentTime;}
	void CutChannel(unsigned int numFrames);

private:
	unsigned int mNumFrames;
	unsigned int mFrameRate;
	double mCurrentTime;
	std::vector<CAnimChannel *> mChannels;
};

#endif /* CTIMELINE_H_ */
