/*
 * Name:     CAnimChannel.h
 *
 *
 * Class:    CAnimChannel
 * Impl:     CAnimChannel.cpp
 * Created : Mar 14, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CANIMCHANNEL_H_
#define CANIMCHANNEL_H_

#include <string>

class CTimeline;

/*
 * Class:    CAnimChannel
 *
 */
class CAnimChannel
{
protected:
    enum InsertActions {Append, Replace, Insert};

    InsertActions GetInsertAction();

public:
    CAnimChannel();
    virtual ~CAnimChannel();

    class Keyframe
    {
    public:

        int GetFrame() const {return mFrame;}
        void SetFrame(int f) {mFrame = f;}

    private:
        int mFrame;
    };

    void SetName(std::wstring name) {mName = name;}
    std::wstring GetName() {return mName;}
    void SetTimeline(CTimeline *timeline) {mTimeline = timeline;}
    CTimeline *GetTimeline() {return mTimeline;}
    virtual int GetNumKeyframes() = 0;
    virtual Keyframe *GetKeyframe(int frame) = 0;
    void SetKeyframeIndices();
    virtual void ClearKeyframe() = 0;

protected:
    int mKeyframe1;
    int mKeyframe2;

private:
    std::wstring mName;
    CTimeline *mTimeline;
};

#endif /* CANIMCHANNEL_H_ */
