/*
 * Name:     CAnimChannelEnable.h
 *
 *
 * Class:    CAnimChannelEnable
 * Impl:     CAnimChannelEnable.cpp
 * Created : Mar 19, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CANIMCHANNELENABLE_H_
#define CANIMCHANNELENABLE_H_

#include "CAnimChannel.h"
#include <vector>

/*
 * Class:    CAnimChannelEnable
 * 
 */
class CAnimChannelEnable : public CAnimChannel
{
public:
	CAnimChannelEnable();
	virtual ~CAnimChannelEnable();

	class KeyframeEnab : public Keyframe
	{
	public:
		bool GetEnab() const {return mEnab;}
		void SetEnab(bool e) {mEnab = e;}
	private:
		bool mEnab;
	};

	int GetNumKeyframes();
	Keyframe *GetKeyframe(int frame);
	void SetKeyframe(bool enable);
	bool GetEnab(bool old);
	void ClearKeyframe();
	void EmptyChannel();

private:
	std::vector<KeyframeEnab> mKeyframes;
};

#endif /* CANIMCHANNELENABLE_H_ */
