/*
 * Name:     CAnimChannelPos.h
 *
 *
 * Class:    CAnimChannelPos
 * Impl:     CAnimChannelPos.cpp
 * Created : Mar 14, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CANIMCHANNELPOS_H_
#define CANIMCHANNELPOS_H_

#include "CAnimChannel.h"
#include <vector>

/*
 * Class:    CAnimChannelPos
 * 
 */
class CAnimChannelPos : public CAnimChannel
{
public:
	CAnimChannelPos();
	virtual ~CAnimChannelPos();

	class KeyframePos : public Keyframe
	{
	public:
		wxPoint GetPos() const {return mPos;}
		void SetPos(wxPoint p) {mPos = p;}
	private:
		wxPoint mPos;
	};

    int GetNumKeyframes();
    Keyframe *GetKeyframe(int frame);
    void SetKeyframe(wxPoint pos);
    wxPoint GetPos(wxPoint old);
    void ClearKeyframe();
    void EmptyChannel();

private:
    std::vector<KeyframePos> mKeyframes;
};

#endif /* CANIMCHANNELPOS_H_ */
