/*
 * Name:     CAnimChannelText.h
 *
 *
 * Class:    CAnimChannelText
 * Impl:     CAnimChannelText.cpp
 * Created : Mar 21, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CANIMCHANNELTEXT_H_
#define CANIMCHANNELTEXT_H_

#include "CAnimChannel.h"
#include <vector>

/*
 * Class:    CAnimChannelText
 * 
 */
class CAnimChannelText : public CAnimChannel
{
public:
	CAnimChannelText();
	virtual ~CAnimChannelText();

	class KeyframeText : public Keyframe
	{
	public:
		std::wstring GetText() const {return mText;}
		void SetText(std::wstring s) {mText = s;}
	private:
		std::wstring mText;
	};

	int GetNumKeyframes();
	Keyframe *GetKeyframe(int frame);
	void SetKeyframe(std::wstring string);
	std::wstring GetText(std::wstring old);
	void ClearKeyframe();
	void EmptyChannel();

private:
	std::vector<KeyframeText> mKeyframes;
};

#endif /* CANIMCHANNELTEXT_H_ */
