/*
 * Name:     CHead.h
 *
 *
 * Class:    CHead
 * Impl:     CHead.cpp
 * Created : Feb 26, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CHEAD_H_
#define CHEAD_H_

#include "CImageDrawable.h"
#include "../Channel/CAnimChannelText.h"

/*
 * Class:    CHead
 * 
 */
class CHead : public CImageDrawable
{
public:

	enum Ids {Harold, DanishCousin, ID_Happy, ID_Angry, ID_Confused, ID_Blank, ID_Sad, ID_Blinking};

	CHead(const std::wstring &name, const std::wstring &filename, int indicator);
	virtual ~CHead();

	virtual void XmlSaveDrawable(wxXmlNode* actor);
	virtual void XmlLoad(std::wstring name, bool defaultParam, wxXmlNode *check);
	virtual void SetTimeline(CTimeline *timeline);
	virtual void Draw(wxDC* dc);
	virtual void DispDiag(CFrame *frame);
	virtual bool IsMovable() {return true;}
	virtual void SetKeyframe();
	virtual void GetKeyframe();
	virtual void ClearKeyframe();
	virtual void ClearChannels();
	void TogBlinks() {mBlinks == false ? mBlinks = true : mBlinks = false;}
	void SetExpression(int face);
	int GetExpression() const {return (int)mFace;}

protected:
	Ids mFace;
	std::list<CDrawable *> mDrawables;
	// Use generic CDrawable, since objects
	// may not be the same for all heads
	CDrawable *mRightEye;
	CDrawable *mRightEyebrow;
	CDrawable *mLeftEye;
	CDrawable *mLeftEyebrow;
	CDrawable *mBothEyes;

private:
	//CHead();
	int mClass;

	bool mInitial;
	wxPoint mTempR;
	wxPoint mTempL;
	int mCurrFace;
	bool mBlinks;

    CAnimChannelText mChannelExpression;
};

#endif /* CHEAD_H_ */
