/*
 * CHeadDlg.h
 *
 *  Created on: Mar 25, 2010
 *      Author: aonokenj
 */

#pragma once
#ifndef CHEADDLG_H_
#define CHEADDLG_H_

#include "CHead.h"
#include "../View/CViewEdit.h"

/*
 * Class:    CHeadDlg
 *
 */
class CHeadDlg : public wxDialog
{
public:
	CHeadDlg(wxWindow *parent, CHead *head, CViewEdit *showHere);
    virtual ~CHeadDlg();

    // Id values for our controls
    enum Ids {ID_Ok, ID_Cancel, ID_Happy, ID_Angry, ID_Confused, ID_Blank, ID_Sad, ID_Blinking};

    void OnOkButton(wxCommandEvent &event);
    void OnCancelButton(wxCommandEvent &event);
    void SetHappyFace(wxCommandEvent &event) {SetFace(ID_Happy);}
    void SetAngryFace(wxCommandEvent &event) {SetFace(ID_Angry);}
    void SetConfusedFace(wxCommandEvent &event) {SetFace(ID_Confused);}
    void SetBlankFace(wxCommandEvent &event) {SetFace(ID_Blank);}
    void SetSadFace(wxCommandEvent &event) {SetFace(ID_Sad);}
    void SetBlinkingFace(wxCommandEvent &event) {SetFace(ID_Blinking);}
    void SetFace(Ids face);

    // Don't put anything between this line and the next
    // private, protected, or public.
    DECLARE_EVENT_TABLE()

private:
    CHeadDlg();

    CHead *mHead;
    CViewEdit *mViewEdit;
    wxButton *mOkButton;
    wxButton *mCancelButton;

    wxButton* mHappy;
    wxButton* mAngry;
    wxButton* mConfused;
    wxButton* mBlank;
    wxButton* mBlink;

    Ids mFace;
    bool mBlinking;
};

#endif /* CHEADDLG_H_ */

