/*
 * Name:     CImageDrawable.h
 *
 *
 * Class:    CImageDrawable
 * Impl:     CImageDrawable.cpp
 * Created : Feb 26, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CIMAGEDRAWABLE_H_
#define CIMAGEDRAWABLE_H_

#include "CDrawable.h"

/*
 * Class:    CImageDrawable
 * 
 */
class CImageDrawable : public CDrawable
{
public:
	CImageDrawable(const std::wstring &name, const std::wstring &filename);
	virtual ~CImageDrawable();

	virtual void Draw(wxDC *dc);
	virtual bool HitTest(wxPoint pos);

	void SetCenter(wxPoint c);
	wxPoint GetCenter() const {return mCenter;}

protected:
	wxImage mImage;
	double mBitmapR;
	wxPoint mBitmapCenter;
	wxImage mRotatedImage;
	wxBitmap mRotatedBitmap;
	wxPoint mCenter;
	bool mRotatedBitmapValid;

private:
	//CImageDrawable();
};

#endif /* CIMAGEDRAWABLE_H_ */
