/*
 * Name:     CNoRotationImageDrawable.h
 *
 *
 * Class:    CNoRotationImageDrawable
 * Impl:     CNoRotationImageDrawable.cpp
 * Created : Feb 26, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CNOROTATIONIMAGEDRAWABLE_H_
#define CNOROTATIONIMAGEDRAWABLE_H_

#include "CImageDrawable.h"

/*
 * Class:    CNoRotationImageDrawable
 * NOTE:     This class could be combined in CImageDrawable, with EnableRot(bool status)
 *           and a conditional for SetRotation on mEnabledRot. However, it is now used
 *           only for the eyes (and vest) so it will be used to add blinking functionality
 * 
 */
class CNoRotationImageDrawable : public CImageDrawable
{
public:
	CNoRotationImageDrawable(const std::wstring &name, const std::wstring &filename);
	virtual ~CNoRotationImageDrawable();
	bool IsRotatable() {return false;}
	bool IsBlinkable() {return true;}

	virtual void Draw(wxDC *dc);
	virtual void SetRotation(double r) {mRot+=r; GetParent()->SetRotation(mRot);}
	//virtual void TogBlink() {mBlinking == false ? mBlinking = true : mBlinking = false;}
	virtual void SetBlinkState(bool b) {mBlinking = b;}

private:
	//CNoRotationImageDrawable();
	double mRot;
	bool mBlinking;
	std::vector<wxPoint> mPoints;
};

#endif /* CNOROTATIONIMAGEDRAWABLE_H_ */
