/*
 * Name:     CTextBubbleDrawable.h
 *
 *
 * Class:    CTextBubbleDrawable
 * Impl:     CTextBubbleDrawable.cpp
 * Created : Mar 21, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CTEXTBUBBLEDRAWABLE_H_
#define CTEXTBUBBLEDRAWABLE_H_

#include "../Channel/CAnimChannelPos.h"
#include "../Channel/CAnimChannelText.h"
#include "CDrawable.h"
#include "../CFrame.h"
#include "CTextBubble.h"

/*
 * Class:    CTextBubbleDrawable
 * 
 */
class CTextBubbleDrawable : public CDrawable, private CTextBubble
{
public:
	CTextBubbleDrawable(const std::wstring &name);
	virtual ~CTextBubbleDrawable();

	virtual void XmlSaveDrawable(wxXmlNode* actor);
	virtual void XmlLoad(std::wstring name, bool defaultParam, wxXmlNode *check);
	virtual void Draw(wxDC* dc);
    virtual bool HitTest(wxPoint pos);
	virtual bool IsMovable() {return true;}
	virtual bool IsRotatable() {return false;}

    std::wstring GetText() const {return CTextBubble::GetText();}
    virtual void SetText(const std::wstring &str) {CTextBubble::SetText(str);}
    void FlipMirror() {CTextBubble::GetMirror() == false ? CTextBubble::SetMirror(true) : CTextBubble::SetMirror(false);}
    virtual std::wstring GetMirr();
    virtual void SetMirr(std::wstring check);
	virtual void SetPosition(wxPoint p);
	virtual wxPoint GetPosition() const {return wxPoint(GetX(), GetY());}
	virtual void SetActor(CActor *actor);
	virtual void SetTimeline(CTimeline *timeline);
	virtual void SetKeyframe();
	virtual void GetKeyframe();
	virtual void ClearKeyframe();
	virtual void ClearChannels();
	virtual void DispDiag(CFrame *frame);
	virtual bool HasDialog() {return true;}
	virtual void SetDefault() {SetText(mDefaultText); SetPosition(mDefaultPos); SetMirror(mMirr);}

private:
	//CTextBubbleDrawable();
	// This would be an encapsulation adaptor...it worked though
	//CTextBubble* mTextBubble;
    CAnimChannelText mChannelTB;
    CAnimChannelPos mChannelP;
	CAnimChannelText mChannelM;

    std::wstring mDefaultText;
    wxPoint mDefaultPos;
    bool mMirr;
};

#endif /* CTEXTBUBBLEDRAWABLE_H_ */
