/*
 * Name:     CParticleSnowflake.cpp
 *
 *
 * Class:    CParticleSnowflake
 * Header:   CParticleSnowflake.h
 * Created : Apr 4, 2010
 * Author :  Kenji Aono
 */

#include "../wx/prec.h"
#include "CParticleSnowflake.h"

/*
 * Name :        CParticleSnowflake::CParticleSnowflake()
 * Description : Particle Snowflake class constructor
 */
CParticleSnowflake::CParticleSnowflake(int framerate) : CParticle(framerate)
{
}

/*
 * Name :        CParticleSnowflake::~CParticleSnowflake()
 * Description : Particle Snowflake class constructor
 */
CParticleSnowflake::~CParticleSnowflake()
{
}

/*
 * Name :        CParticleSnowflake::Draw()
 * Description : Draw a snowflake (particle) to the dc
 * Parameters :  dc - the context to draw to
 * Returns :     none
 */
void CParticleSnowflake::Draw(wxDC *dc)
{
    wxBrush brush(wxColour(245, 245, 245));
    dc->SetBrush(brush);
    // Almost pure white
    wxPen pen(wxColour(245, 245, 245), 1, wxTRANSPARENT);
    dc->SetPen(pen);

    dc->DrawCircle(wxPoint(mPosition.x, mPosition.y), 2);

    dc->SetBrush(wxNullBrush);
    dc->SetPen(wxNullPen);
}
