/*
 * Name:     CSingleLinkedList.cpp
 *
 *
 * Class:    CSingleLinkedList
 * Header:   CSingleLinkedList.h
 * Created : Apr 4, 2010
 * Author :  Kenji Aono
 */

#include "../wx/prec.h"
#include "CSingleLinkedList.h"

/*
 * Name :        CSingleLinkedList::CSingleLinkedList()
 * Description : Single Linked List class constructor
 */
CSingleLinkedList::CSingleLinkedList()
{
	begin_ptr = NULL;
}

/*
 * Name :        CSingleLinkedList::~CSingleLinkedList()
 * Description : Single Linked List class constructor
 */
CSingleLinkedList::~CSingleLinkedList()
{
}

/*
 * Name :        CSingleLinkedList::AddParticle()
 * Description : Add a particle to the list
 * Parameters :  p - the particle to add
 * Returns :     none
 */
void CSingleLinkedList::AddParticle(CParticle* p)
{
	SLLNode *temp, *iter;
	temp = new SLLNode;
	temp->mNext = NULL;
	temp->mParticle = p;
	// If the list is empty
	if (begin_ptr == NULL)
	{
		begin_ptr = temp;
	}
	// Otherwise add to the end
	else
	{
		iter = begin_ptr;
		while (iter->mNext != NULL)
		{
			iter = iter->mNext;
		}
		iter->mNext = temp;
	}
}

/*
 * Name :        CSingleLinkedList::RemoveParticle()
 * Description : Remove a particle from the list
 * Parameters :  p - the particle to remove
 * Returns :     none
 */
CParticle* CSingleLinkedList::RemoveParticle()
{
	SLLNode *temp;
	temp = begin_ptr;

	begin_ptr = begin_ptr->mNext;
	return temp->mParticle;
}
