/*
 * Name:     CViewTimeline.h
 * A view window that will display our timeline for animation editing.
 *
 * Class:    CViewTimeline
 * Impl:     CViewTimeline.cpp
 * Created : Feb 20, 2010
 * Author :  Charles B. Owen - Initial distributed version
 * Co-Author: Kenji Aono
 */

#pragma once
#ifndef CVIEWTIMELINE_H_
#define CVIEWTIMELINE_H_

#include "../CDocumentObserver.h"

class CFrame;

/*
 * Class:    CViewTimeline
 * 
 */
class CViewTimeline : public wxScrolledWindow, public CDocumentObserver
{
public:
    CViewTimeline(CFrame *parent);
    virtual ~CViewTimeline();

    void OnPaint(wxPaintEvent &event);
	void OnLeftButtonDown(wxMouseEvent& event);
	void OnMouseMove(wxMouseEvent& event);

    void UpdateObserver();
    void TogActive() {mActive == false ? mActive = true : mActive = false;}

    // Notice:  Don't put anything between DECLARE_EVENT_TABLE() and private:
    DECLARE_EVENT_TABLE()

private:
    CFrame *mFrame;
    wxBitmap  mPointer;
    bool mMovingPointer;
    bool mActive;
};

#endif /* CVIEWTIMELINE_H_ */
